#include "material.h"

Material* Material::firstMat = NULL;
Material* Material::currentMat = NULL;

Material::Material()
{
  init();
}

Material::Material (char* mtlName)
{
  init();
  
  setName (mtlName);
}

void Material::init(void)
{
  if (firstMat == NULL)
    firstMat = this;
  else 
    currentMat->nextMat = this;
  currentMat = this;
  nextMat = NULL;
}


void Material::setName (char* mtlName)
{
  name = mtlName;
  //printf ("adding new Material: %s, %p\n", firstMat->name, firstMat);

}


void Material::setIllum (int illum)
{
  illumModel = illum;
  //  printf ("setting illumModel to: %i\n", illumModel);
}
void Material::setIllum (char* illum)
{
  setIllum (atoi(illum));
}

void Material::setDiffuse (float r, float g, float b)
{
  diffuse[0] = r;
  diffuse[1] = g;
  diffuse[2] = b;
  printf ("setting Diffuse Color to r=%f g=%f b=%f\n", r, g, b);
}
void Material::setDiffuse (char* rgb)
{
  char r[20],g[20],b[20];
  sscanf (rgb, "%s %s %s", r, g, b);
  setDiffuse (atof(r), atof(g), atof(b));
}

void Material::setAmbient (float r, float g, float b)
{
  ambient[0] = r;
  ambient[1] = g;
  ambient[2] = b;
  printf ("setting Ambient Color to r=%f g=%f b=%f\n", r, g, b);
}
void Material::setAmbient (char* rgb)
{
  char r[20],g[20],b[20];
  sscanf (rgb, "%s %s %s", r, g, b);
  setAmbient (atof(r), atof(g), atof(b));
}

void Material::setSpecular (float r, float g, float b)
{
  specular[0] = r;
  specular[1] = g;
  specular[2] = b;
  printf ("setting Specular Color to r=%f g=%f b=%f\n", r, g, b);
}
void Material::setSpecular (char* rgb)
{
  char r[20],g[20],b[20];
  sscanf (rgb, "%s %s %s", r, g, b);
  setSpecular (atof(r), atof(g), atof(b));
}


void Material::setTransparency (float trans)
{
  transparency = trans;
}
void Material::setTransparency (char* trans)
{
  char tr[20];
  sscanf (trans, "%s", tr);
  setTransparency (atof(tr));
}
