#ifndef _MATERIAL_H
#define _MATERIAL_H
#include <GL/gl.h>
#include <GL/glu.h>
#include <stdlib.h>
#include <fstream.h>

class Material
{
 public:
  Material ();
  Material (char* mtlName);
  void init(void);
  ~Material ();
  
  void setName (char* mtlName);
  void setIllum (int illum);
  void setIllum (char* illum);
  void setDiffuse (float r, float g, float b);
  void setDiffuse (char* rgb);
  void setAmbient (float r, float g, float b);
  void setAmbient (char* rgb);
  void setSpecular (float r, float g, float b);
  void setSpecular (char* rgb);
  void setTransparency (float trans);
  void setTransparency (char* trans);


  bool select (void);

 private:
  char* name;
  int illumModel;
  float diffuse [3];
  float ambient [3];
  float specular [3];
  float transparency;

  Material* nextMat;
  static Material* firstMat;
  static Material* currentMat;
};
#endif
